package paysafecard;

import static com.sun.org.apache.xalan.internal.xsltc.compiler.util.Type.String;
import java.awt.Component;
import java.awt.List;
import static java.awt.SystemColor.text;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import static java.rmi.Naming.list;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import static java.util.Collections.list;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import static paysafecard.Main.PASSWORD;
import static paysafecard.Main.PRODUCTIVE;
import static paysafecard.Main.USER;
import static paysafecard.Main.UTC_OFFSET;

public class Directpayout extends javax.swing.JFrame {

    private static String line;
    private HashMap<String, String> tmp = new HashMap<String, String>();
    private ArrayList<String> currencys = new ArrayList<String>();
    private ArrayList<String> anoemail = new ArrayList<String>();
    private ArrayList<Map<String, String>> account = new ArrayList<Map<String, String>>();

    private Map<java.lang.String, java.lang.String> data;
    private Map<java.lang.String, java.lang.String> accountdata;
    private java.lang.String newDateString;
    private Float moneyam;
    private HashMap<java.lang.String, Integer> nameshash;

    /**
     * Creates new form directPayout
     */
    public Directpayout() throws ParseException {
        initComponents();
        loadData("currencys", null);

        for (int i = 0; i < currencys.size(); i++) {
            jComboBox1.addItem(currencys.get(i));
        }

    }

    private void loadData(String type, String email) throws ParseException {
        try {
            BufferedReader br = new BufferedReader(new FileReader("./customer-list.csv"));
            String[] names = br.readLine().split(",");
            nameshash = new HashMap<String, Integer>();
            for (int i = 0; i < names.length; i++) {
                nameshash.put(names[i].toString(), i);
            }

            while ((line = br.readLine()) != null) {
                if (!line.isEmpty()) {
                    // use comma as separator
                    String[] data = line.split(",");
                    if (!type.equals("account")) {
                        if (!currencys.contains(data[nameshash.get("CURRENCY")])) {
                            currencys.add(data[nameshash.get("CURRENCY")]);
                        }
                    } else if (email == null) {
                        anoemail.add(data[nameshash.get("EMAIL")]);
                    } else if (email.equals(data[nameshash.get("EMAIL")])) {
                        tmp = new HashMap<String, String>();
                        tmp.put("CUSTOMER_NO", data[nameshash.get("CUSTOMER_NO")]);
                        tmp.put("FIRST_NAME", data[nameshash.get("FIRST_NAME")]);
                        tmp.put("LAST_NAME", data[nameshash.get("LAST_NAME")]);
                        SimpleDateFormat sdf = new SimpleDateFormat("dd.mm.yyyy");
                        Date d = sdf.parse(data[nameshash.get("DATE_OF_BIRTH")]);
                        sdf.applyPattern("yyyy-mm-dd");
                        newDateString = sdf.format(d);
                        tmp.put("DATE_OF_BIRTH", newDateString);
                        account.add(tmp);
                    }
                }
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ArrayIndexOutOfBoundsException e) {
            return;
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        email = new javax.swing.JTextField();
        money = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jButton1.setText("Submit");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1MouseClicked(evt);
            }
        });

        email.setText("Email");

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jTextArea1.setToolTipText("");
        jScrollPane1.setViewportView(jTextArea1);

        jTextArea2.setColumns(20);
        jTextArea2.setRows(5);
        jScrollPane2.setViewportView(jTextArea2);

        jLabel1.setText("Debug");

        jLabel2.setText("Results");

        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });

        jLabel3.setText("Amount");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(email)
                            .addComponent(money, javax.swing.GroupLayout.PREFERRED_SIZE, 129, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel3))
                .addGap(33, 33, 33)
                .addComponent(jButton1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 448, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 35, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 396, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(25, 25, 25))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 360, Short.MAX_VALUE)
                    .addComponent(jScrollPane1))
                .addGap(44, 44, 44)
                .addComponent(email, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(money, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBox1))
                .addGap(20, 20, 20))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBox1ActionPerformed

    private void jButton1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1MouseClicked

        try {
            loadData("account", email.getText());
        } catch (ParseException ex) {
            Logger.getLogger(Directpayout.class.getName()).log(Level.SEVERE, null, ex);
        }
        accountdata = account.get(0);
        java.lang.String number = money.getText();
        double amount = Double.parseDouble(Float.valueOf(number).toString());
        DecimalFormat formatter = new DecimalFormat("#.00");

        Payout payout = new Payout(USER, PASSWORD, PRODUCTIVE);
        payout.setTransaction(money.getText(), jComboBox1.getSelectedItem().toString(), "", UTC_OFFSET);
        payout.setCustomer(accountdata.get("CUSTOMER_NO"), email.getText(), "EMAIL");
        payout.setCustomerDetails(accountdata.get("FIRST_NAME"), accountdata.get("LAST_NAME"), accountdata.get("DATE_OF_BIRTH"));
        try {
            payout.payoutDo("true");
            if (payout.getResultCode().equals("0")) {
                jTextArea1.setText("Your payout request was successful! \n");
                jTextArea1.append("The amount of " + formatter.format(amount) + jComboBox1.getSelectedItem().toString() + " was transfered to your my paysafecard account.\n");
            } else {
                jTextArea1.setText(payout.getError(payout.getResultCode()) + "\n");
                jTextArea1.append(payout.getResultCode() + "\n");
                jTextArea1.append(payout.getErrorCode() + "\n");
                jTextArea1.append(payout.getErrorCodeDescription() + "\n");
            }

            jTextArea2.setText(new XmlFormatter().format(payout.getSoapResponse()));
        } catch (Exception ex) {
            Logger.getLogger(Directpayout.class.getName()).log(Level.SEVERE, null, ex);
        }

    }//GEN-LAST:event_jButton1MouseClicked

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Directpayout.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Directpayout.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Directpayout.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Directpayout.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                try {
                    new Directpayout().setVisible(true);
                } catch (ParseException ex) {
                    Logger.getLogger(Directpayout.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField email;
    private javax.swing.JButton jButton1;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    public static javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextField money;
    // End of variables declaration//GEN-END:variables
}
